searchNodes=[{"ref":"Jorb.html","title":"Jorb","type":"module","doc":"Jorb I uh, I say you did a great jorb out there What Jorb is a simple queue-based jobs processing system for Elixir. Works great with Amazon SQS. How Define your job module: defmodule HelloWorld.Job do use Jorb.Job def read_queues do [&quot;high_priority_greetings&quot;, &quot;regular_greetings&quot;] end def write_queue(greeting) do if greeting[&quot;name&quot;] == &quot;Zeke&quot; do &quot;high_priority_greetings&quot; else &quot;regular_greetings&quot; end end def perform(greeting) do IO.puts &quot;Hello, \#{greeting[&quot;name&quot;]}!&quot; :ok end end Enqueue work: HelloWorld.Job.enqueue(%{&quot;name&quot; =&gt; &quot;Ray&quot;}) Perform work: # poll queues once HelloWorld.Job.work(read_timeout: 1000, perform_timeout: 5000) # poll queues forever HelloWorld.Job.workers(worker_count: 2, read_interval: 1000) |&gt; Supervisor.start_link(strategy: :one_for_one) Installation Put the following into your mix.exs file&#39;s deps function: {:jorb, &quot;~&gt; 0.4.0&quot;} Configuration In order of priority, configs can be provided by: Passing options in the opts parameter to each function Configuring your job module in config/config.exs: config :jorb, HelloWorld.Job, [read_timeout: 5000] Configuring global Jorb settings in config/config.exs: config :jorb, write_batch_size: 10 Options: :backend - the module implementing Jorb.Backend, default Jorb.Backend.Memory. You should set this to something else (like Jorb.Backend.SQS in production. :reader_count - number of read workers to launch per job module, default System.schedulers_online(). :writer_count - number of message batch writers to launch, default 1. :write_batch_size - number of messages to write at once, default 1. :write_interval - milliseconds to wait before flushing outgoing messages, default 1000. :write_queues - list of queue names that might be written to. :read_batch_size - number of messages to read at once, default 1. :read_interval - milliseconds to sleep between fetching messages, default 1000. :read_duration - milliseconds to hold connection open when polling for messages, default 1000. :read_timeout - milliseconds before giving up when reading messages, default 2000. :perform_timeout - milliseconds before giving up when performing a single job, default 5000."},{"ref":"Jorb.html#t:message/0","title":"Jorb.message/0","type":"type","doc":""},{"ref":"Jorb.html#t:queue/0","title":"Jorb.queue/0","type":"type","doc":""},{"ref":"Jorb.Backend.html","title":"Jorb.Backend","type":"behaviour","doc":"The Jorb.Backend behaviour represents a queueing abstraction."},{"ref":"Jorb.Backend.html#c:create_queue/2","title":"Jorb.Backend.create_queue/2","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:delete_message/3","title":"Jorb.Backend.delete_message/3","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:delete_queue/2","title":"Jorb.Backend.delete_queue/2","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:message_body/1","title":"Jorb.Backend.message_body/1","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:purge_queue/2","title":"Jorb.Backend.purge_queue/2","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:read_messages/2","title":"Jorb.Backend.read_messages/2","type":"callback","doc":""},{"ref":"Jorb.Backend.html#c:write_messages/3","title":"Jorb.Backend.write_messages/3","type":"callback","doc":""},{"ref":"Jorb.Backend.html#t:body/0","title":"Jorb.Backend.body/0","type":"type","doc":""},{"ref":"Jorb.Backend.html#t:message/0","title":"Jorb.Backend.message/0","type":"type","doc":""},{"ref":"Jorb.Backend.html#t:opts/0","title":"Jorb.Backend.opts/0","type":"type","doc":""},{"ref":"Jorb.Backend.html#t:queue/0","title":"Jorb.Backend.queue/0","type":"type","doc":""},{"ref":"Jorb.Backend.Memory.html","title":"Jorb.Backend.Memory","type":"module","doc":"A memory-backed backend for Jorb. Suitable for testing."},{"ref":"Jorb.Backend.Memory.html#child_spec/1","title":"Jorb.Backend.Memory.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Jorb.Backend.Memory.html#start_link/0","title":"Jorb.Backend.Memory.start_link/0","type":"function","doc":""},{"ref":"Jorb.Backend.SQS.html","title":"Jorb.Backend.SQS","type":"module","doc":""},{"ref":"Jorb.Job.html","title":"Jorb.Job","type":"behaviour","doc":"Modules that use Jorb.Job can enqueue, read, and perform jobs. These modules must implement the Jorb.Job behaviour. In addition to the callbacks defined in Jorb.Job, these modules also export the enqueue/2, work/1, and workers/1 functions. See the documention below for enqueue/3, work/2, and workers/2. See Jorb for more documentation."},{"ref":"Jorb.Job.html#enqueue/3","title":"Jorb.Job.enqueue/3","type":"function","doc":"Queue a job to be performed by this module&#39;s perform/1 function later. Intended for use through modules that use Jorb.Job."},{"ref":"Jorb.Job.html#c:perform/1","title":"Jorb.Job.perform/1","type":"callback","doc":"Performs the given work. Behind the scenes, the message from which the work originated will be deleted from the queue if this function returns :ok."},{"ref":"Jorb.Job.html#c:read_queues/0","title":"Jorb.Job.read_queues/0","type":"callback","doc":"List of queues to fetch jobs from, given in highest-priority-first order."},{"ref":"Jorb.Job.html#work/2","title":"Jorb.Job.work/2","type":"function","doc":"Attempt to fetch jobs to do, reading from the first item in read_queues/0 that has messages. For each message received, perform/1 is invoked, deleting the message if the return value is :ok. Intended for use through modules that use Jorb.Job."},{"ref":"Jorb.Job.html#workers/2","title":"Jorb.Job.workers/2","type":"function","doc":"Returns a list of child specs for GenServers that read ( execute work(opts) forever) and write (flush batches of outgoing messages). Intended for use through modules that use Jorb.Job."},{"ref":"Jorb.Job.html#c:write_queue/0","title":"Jorb.Job.write_queue/0","type":"callback","doc":"Queue to write to. Implement this or write_queue/1."},{"ref":"Jorb.Job.html#c:write_queue/1","title":"Jorb.Job.write_queue/1","type":"callback","doc":"Queue to write to, for the given payload. Implement this or write_queue/0."},{"ref":"readme.html","title":"Jorb","type":"extras","doc":"Jorb I uh, I say you did a great jorb out there"},{"ref":"readme.html#what","title":"Jorb - What","type":"extras","doc":"Jorb is a simple queue-based jobs processing system for Elixir. Works great with Amazon SQS."},{"ref":"readme.html#how","title":"Jorb - How","type":"extras","doc":"Define your job module: defmodule HelloWorld.Job do use Jorb.Job def read_queues do [&quot;high_priority_greetings&quot;, &quot;regular_greetings&quot;] end def write_queue(greeting) do if greeting[&quot;name&quot;] == &quot;Zeke&quot; do &quot;high_priority_greetings&quot; else &quot;regular_greetings&quot; end end def perform(greeting) do IO.puts &quot;Hello, \#{greeting[&quot;name&quot;]}!&quot; :ok end end Enqueue work: HelloWorld.Job.enqueue(%{&quot;name&quot; =&gt; &quot;Ray&quot;}) Perform work: # poll queues once HelloWorld.Job.work(read_timeout: 1000, perform_timeout: 5000) # poll queues forever HelloWorld.Job.workers(worker_count: 2, read_interval: 1000) |&gt; Supervisor.start_link(strategy: :one_for_one)"},{"ref":"readme.html#installation","title":"Jorb - Installation","type":"extras","doc":"Put the following into your mix.exs file&#39;s deps function: {:jorb, &quot;~&gt; 0.4.0&quot;}"},{"ref":"readme.html#configuration","title":"Jorb - Configuration","type":"extras","doc":"In order of priority, configs can be provided by: Passing options in the opts parameter to each function Configuring your job module in config/config.exs: config :jorb, HelloWorld.Job, [read_timeout: 5000] Configuring global Jorb settings in config/config.exs: config :jorb, write_batch_size: 10 Options: :backend - the module implementing Jorb.Backend, default Jorb.Backend.Memory. You should set this to something else (like Jorb.Backend.SQS in production. :reader_count - number of read workers to launch per job module, default System.schedulers_online(). :writer_count - number of message batch writers to launch, default 1. :write_batch_size - number of messages to write at once, default 1. :write_interval - milliseconds to wait before flushing outgoing messages, default 1000. :read_batch_size - number of messages to read at once, default 1. :read_interval - milliseconds to sleep between fetching messages, default 1000. :read_duration - milliseconds to hold connection open when polling for messages, default 1000. :read_timeout - milliseconds before giving up when reading messages, default 2000. :perform_timeout - milliseconds before giving up when performing a single job, default 5000."},{"ref":"readme.html#installation","title":"Jorb - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding jorb to your list of dependencies in mix.exs: def deps do [ {:jorb, &quot;~&gt; 0.3.0&quot;} ] end"},{"ref":"readme.html#authorship-license","title":"Jorb - Authorship &amp; License","type":"extras","doc":"Jorb is copyright 2018 Appcues, Inc. Jorb is licensed under the MIT license. A Jorb Well Done is by The Brothers Chaps."}]